   --       ,
   --    (Integer,Double).
   --     , .. -
   --      "" (map).
   --
   -- : .., .. (24.05.2008,
   --                                      10.07.2012)
   -- ************************************************
   module AList
      (assoc, assoc_if, rassoc, rassoc_if, assFind, assFind',
       acons, acons1, acons2, pairlis,
       delpair, putassoc,
       rekey, redata,
       bubbleKey, bubbleDate, pKey, pDate)
   where
   -- ******************************************************
   -- ,     
   --  alist ,        fst-
   --    key   test   
   -- False. 
   --    ,   , ,
   --      ;  -
   --   
   -------------------------------------
   assoc:: Integer -> [(Integer,Double)]
                   -> (Integer -> Integer -> Bool)
                   -> [(Integer,Double)]
   assoc key alist test | null alist = []
                        | test (fst (head alist)) key
                                     = [head alist]
                        | True       = assoc key (tail alist) test
   ---------------------------------------------------------------
   -- ,      -
   --  alist ,          fst-
   --   test    False.  
   --   ,  , ,  -
   --     ;  -  
   -------------------------------------------------------
   assoc_if:: [(Integer,Double)] -> (Integer -> Bool)
                                 -> [(Integer,Double)]
   assoc_if alist test | null alist = []
                       | test (fst (head alist))
                                    = [head alist]
                       | True       = assoc_if (tail alist) test
   ---------------------------------------------------------------
   -- ,      -
   --  alist ,          snd-
   --   key   test    False.  
   --   ,  , ,  -
   --     ;  -  
   -------------------------------------------------------
   rassoc:: Double -> [(Integer,Double)]
                   -> (Double -> Double -> Bool)
                   -> [(Integer,Double)]
   rassoc key alist test | null alist = []
                         | test (snd (head alist)) key
                                      = [head alist]
                         | True       = rassoc key 
                                               (tail alist) test
   -------------------------------------------------------------
   -- ,     
   --  alist ,        snd-
   --    test    False.  
   --   ,    , ,
   --         ;  - 
   -- 
   --------------------------------------------------
   rassoc_if:: [(Integer,Double)] -> (Double -> Bool)
                                  -> [(Integer,Double)]
   rassoc_if alist test | null alist = []
                        | test (snd (head alist))
                                     = [head alist]
                        | True       = rassoc_if (tail alist) test
   ---------------------------------------------------------------
   --   True,   (key,date) 
   --    alist
   -- (  )
   ---------------------------------------------------------
   assFind:: Integer -> Double -> [(Integer,Double)] -> Bool
   assFind key date alist | null alist = False
                          | key==fst (head alist)&&
                            date==snd (head alist)
                                       = True
                          | True       = assFind key date 
                                                 (tail alist)
   -----------------------------------------------------------
   --   True,   (key,date) 
   --    alist
   -- (  )
   ----------------------------------------------------------
   assFind':: Integer -> Double -> [(Integer,Double)] -> Bool
   assFind' key date []          = False
   assFind' key date ((k,d):lst) = k==key && d==date
                                   || assFind' key date lst
   -- ******************************************************
   -- ,   (x,y)   -
   --   alist.
   --          x
   ------------------------------------------------------
   acons:: Integer -> Double -> [(Integer,Double)]
                             -> [(Integer,Double)]
   acons x y alist = (x,y) : alist
   ----------------------------------------------------------
   --   (  ) 
   --  (x,y)      alist, 
   --      
   ----------------------------------------------------
   acons1:: Integer -> Double -> [(Integer,Double)]
                              -> [(Integer,Double)]
   acons1 x y alist | null alist         = [(x,y)]
                    | x>fst (head alist) = head alist : 
                                           acons1 x y (tail alist)
                    | True               = (x,y) : alist
   -----------------------------------------------------------
   --   (  ) -
   --   (x,y)    alist,   -
   --      .
   --   (x,y)   ,    
   -------------------------------------------------------
   acons2:: Integer -> Double -> [(Integer,Double)]
                              -> [(Integer,Double)]
   acons2 x y alist 
         | null alist          = [(x,y)]
         | y<snd (head alist)  = head alist : 
                                 acons2 x y (tail alist)
         | y>snd (head alist)  = (x,y) : alist
         | x==fst (head alist) = acons2 x y (tail alist)
         | True                = head alist : 
                                 acons2 x y (tail alist)
   -----------------------------------------------------------
   --       -
   --  lkey       ldata      
   -- (head lkey,head ldata)    alist
   -----------------------------------------------------
   pairlis:: [Integer] -> [Double] -> [(Integer,Double)]
                                   -> [(Integer,Double)]
   pairlis lkey ldata alist | null lkey || null ldata
                                   = alist
                            | True = (head lkey,head ldata) :
                                     pairlis (tail lkey)
                                             (tail ldata) alist
   -- *********************************************************
   --       key 
   --   alist
   -------------------------------------------------------------
   delpair:: Integer -> [(Integer,Double)] -> [(Integer,Double)]
   delpair key alist 
         | null alist            = []
         | fst (head alist)==key = delpair key (tail alist)
         | True                  = head alist :
                                   delpair key (tail alist)
   ------------------------------------------------------------
   --      alist , -
   --   key,   dta   -
   --    alist
   ---------------------------------------------------
   putassoc:: Integer -> Double -> [(Integer,Double)]
                                -> [(Integer,Double)]
   putassoc key dta alist 
         | null alist = []
         | fst (head alist)/=key
                      = head alist : putassoc key dta (tail alist)
         | True       = (fst (head alist),dta) :
                        putassoc key dta (tail alist)
   -- **************************************************
   --      
   --  alist
   ---------------------------------------
   rekey:: [(Integer,Double)] -> [Integer]
   rekey aList = map (\(x,_) -> x) aList
   -----------------------------------------------------
   --      
   --  alist
   ---------------------------------------
   redata:: [(Integer,Double)] -> [Double]
   redata aList = map (\(_,y) -> y) aList
   -- *******************************************************
   --      
   --  aLst    
   ------------------------------------
   bubbleKey aLst
     | null aLst = aLst
     | True      = bubbleKey (reverse (tail (reverse (pKey aLst))))
                   ++ [head (reverse (pKey aLst))]
   ---------------------------------------------------
   --  ,   
   --    
   -------------------------
   pKey aLst | length aLst<2                                  
                        = aLst                                
             | fst (head aLst)>fst (head (tail aLst))         
                        = head (tail aLst) : pKey (head aLst  
                                           : tail (tail aLst))
             | True     = head aLst : pKey (tail aLst)        
   ----------------------------------------------------------
   --      
   --  aLst    
   ------------------------------------
   bubbleDate aLst
     | null aLst = aLst
     | True      = 
         bubbleDate (reverse (tail (reverse (pDate aLst))))
         ++ [head (reverse (pDate aLst))]
   ---------------------------------------------------
   --  ,   
   --    
   ---------------------------------
   pDate aLst | length aLst<2 = aLst
              | snd (head aLst)>snd (head (tail aLst)) 
                              = head (tail aLst) :
                                pDate (head aLst : tail (tail aLst))
              | True          = head aLst : pDate (tail aLst)
